package cn.estsh.i3plus.core.api.iservice.busi;


import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;

import java.util.List;

/**
 * @Description : 系统功能业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 15:18:14.958
 * @Modify      :
 **/
public interface ISysMenuService {

    /**
     * 修改数据
     *
     * @param sysMenu
     */
    void updateSysMenu(SysMenu sysMenu);

    /**
     * 修改权限状态
     * @param id        修改权限状态
     * @param status    状态
     * @param user      当前会话用户
     * @return
     */
    void updateSysMenuStatus(Long id, int status, SessionUser user);

    /**
     * 批量修改状态
     * @param ids
     * @param status
     * @param user
     */
    void updateSysMenuStatusByIds(Long[] ids, int status, SessionUser user);

    /**
     * 根据Key 删除数据
     * @param id
     * @return
     */
    void deleteSysMenuById(Long id);

    /**
     * 根据id批量删除
     * @param ids id数组
     * @return
     */
    void deleteSysMenuByIds(Long[] ids);

    /**
     * 新增数据
     *
     * @param sysMenu
     * @return
     */
    SysMenu insertSysMenu(SysMenu sysMenu);

    /**
     * 查询所有数据
     *
     * @return
     */
    List<SysMenu> findSysMenuAll();

    /**
     * 根据id 数据
     *
     * @param id
     * @return
     */
    SysMenu getSysMenuById(Long id);

    /**
     * 复杂查询
     * @param menu
     * @param pager
     * @return
     */
    ListPager<SysMenu> querySysMenu(SysMenu menu, Pager pager);



}
